package com.unipi.talepis.protal3;

import android.Manifest;
import android.content.pm.PackageManager;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends AppCompatActivity implements LocationListener {
    final static int REQUESTCODE = 324;
    LocationManager locationManager;
    TextView textView;
    SQLiteDatabase db;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        locationManager = (LocationManager) getSystemService(LOCATION_SERVICE);
        textView = findViewById(R.id.textView);
        db = openOrCreateDatabase("DemoUsers",MODE_PRIVATE,null);
        db.execSQL("CREATE TABLE IF NOT EXISTS 'DemoUserTable' (" +
                "'user_id' TEXT," +
                "'user_name' TEXT," +
                "'user_tel' TEXT," +
                "PRIMARY KEY('user_id'))");
        db.execSQL("INSERT OR IGNORE INTO 'DemoUserTable' VALUES" +
                "('1','talepis','2104142311');");
        db.execSQL("INSERT OR IGNORE INTO 'DemoUserTable' VALUES" +
                "('2','john1','2112222223');");
        db.execSQL("INSERT OR IGNORE INTO 'DemoUserTable' VALUES" +
                "('3','maria13','210111111');");
    }

    public void insert(View view){
        db.execSQL("INSERT INTO 'DemoUserTable' VALUES" +
                "('4','georgeunipi','6944123456');");
    }

    @Override
    public void onRequestPermissionsResult(int requestCode,
                                           @NonNull String[] permissions,
                                           @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        if (grantResults[0] == PackageManager.PERMISSION_GRANTED)
            //Toast.makeText(this,"Yesss I have GPS",Toast.LENGTH_SHORT).show();
            if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)
                    == PackageManager.PERMISSION_GRANTED) {
                locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER, 0, 0,
                        this);
            } else
            Toast.makeText(this,"Pleaaaaase I really need this permission!...",Toast.LENGTH_SHORT).show();
    }

    public void giveperm(View view){
        if (ActivityCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)
        != PackageManager.PERMISSION_GRANTED){
            ActivityCompat.requestPermissions(this,
                    new String[]{Manifest.permission.ACCESS_FINE_LOCATION},
                    REQUESTCODE);
        }else{
            //Toast.makeText(this,"Permission already Granded!",Toast.LENGTH_SHORT).show();
            locationManager.requestLocationUpdates(LocationManager.GPS_PROVIDER,0,0,
                    this);
        }
    }

    public void gpsoff(View view){
        locationManager.removeUpdates(this);
        }

    @Override
    public void onLocationChanged(Location location) {
        textView.setText(String.valueOf(location.getLatitude())+","+
                String.valueOf(location.getLongitude()));
        //location.getSpeed();
    }

    @Override
    public void onStatusChanged(String provider, int status, Bundle extras) {

    }

    @Override
    public void onProviderEnabled(String provider) {

    }

    @Override
    public void onProviderDisabled(String provider) {

    }
    public void getall(View view){
        StringBuffer buffer = new StringBuffer();
        Cursor cursor = db.rawQuery("SELECT * FROM DemoUserTable",null);
        if (cursor.getCount()!=0){
            while (cursor.moveToNext()){
                buffer.append("User ID:"+cursor.getString(0)+"\n");
                buffer.append("User Name:"+cursor.getString(1)+"\n");
                buffer.append("User Telephone:"+cursor.getString(2)+"\n");
                buffer.append("-----------------------------------\n");
            }
            showMessage("Records",buffer.toString());
        }
    }
    public void update(View view){
        db.execSQL("UPDATE DemoUserTable SET user_name='efthimios' WHERE user_id='1';");
    }
    public void showMessage(String title, String message){
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle(title);
        builder.setMessage(message);
        builder.setCancelable(true);
        builder.show();
    }
}
